<num-input>
<div id="{divid}">
	<wms-label if="{opts.typef != null}" for="{flid}" value="{typef}" id="{flid}"></wms-label>
	<input type="text" id="{id}" name="{name}" maxlength="{maxlength}" data-group="{dataGroup}" data-idx="{dataIdx}" style="text-align: right; {style}" class="{css}" onkeyup={keyupfunc} value="{value}" data-type="num" data-allowdecimal="{allowdecimal}" data-precision="{precision}" placeholder="{placeholder}" onfocus={focusFunc} onblur={blurFunc}>
	<wms-label if="{opts.typee != null}" for="{elid}" value="{typee}" id="{elid}"></wms-label>
	<message tagid="{messageid}" msgstyle="{msgstyle}"></message>
</div>
<script>
	this.id = opts.tagid;
	this.name = (opts.name) ? opts.name : opts.tagid;
	this.divid = opts.tagid + 'Div';
	this.messageid = opts.tagid + 'MessageDiv';
	this.maxlength = opts.maxlength;
	this.dataGroup = opts.dataGroup;
	this.dataIdx = opts.dataIdx;
	this.css = 'bakyel ' + (opts.css ? opts.css : '');
	this.style = 'ime-mode: disabled;' + (opts.style ? opts.style : '');
	this.fmt = opts.fmt ? opts.fmt : '';this.flid = opts.tagid + 'Fl';
	this.flid = opts.tagid + 'Fl';
	this.elid = opts.tagid + 'El';
	this.typef = opts.typef ? opts.typef : '';
	this.typee = opts.typee ? opts.typee : '';
	this.placeholder = opts.placeholder ? opts.placeholder : '';
	this.value = opts.value ? opts.value : opts.riotValue;
	this.msgstyle = opts.msgstyle;
	this.allowdecimal = opts.allowdecimal;
	this.precision = opts.precision;

	keyupfunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
	}

	// フォーカスin時の値を保持
	this._tmpVal = this.value;
	
	/**
	 * フォーカスin時の処理
	 */
	focusFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		this._tmpVal = $('#' + this.id).val();
		$('#' + this.id).val($('#' + this.id).val().replaceAll(',', ''));
	}

	/**
	 * フォーカスout時の処理
	 */
	blurFunc(e) {
		e.preventUpdate = true; // タグは自動では更新されない
		var aftVal = $('#' + this.id).val();
		if (this._tmpVal != aftVal) {
			updFlg = true;
			$('#' + this.id).attr('data-updflg', '1');
		}
		var vfOpts = {
				'allowdecimal' : this.allowdecimal ? this.allowdecimal : true,
				'precision' : this.precision ? this.precision : 0
		};
		var val = aftVal.replaceAll(',', '').replace(/[^0-9-.]|\.\..*$/igm,'');
		if (val != '') {
			val = valueFomatter('num', val, vfOpts);
			$('#' + this.id).val(val);
		}
		if (opts.onblurfunc != null) {
			opts.onblurfunc();
		}
	}

	/**
	 * マウント時の処理
	 */
	this.on('mount', function() {
		var vfOpts = {
				'allowdecimal' : this.allowdecimal ? Boolean(this.allowdecimal) : true,
				'precision' : this.precision ? Number(this.precision) : 0
		};
		$('#' + this.id).val(valueFomatter('num', this.value, vfOpts));
	});

	/**
	 * マウント時の処理
	 */
	this.on('updated', function() {
		setDataObj(opts.tagid, opts);
	});
	
	/**
	 * キーがデータ属性に使用するキーかどうか
	 */
	function isDataAttrKey(key) {
		return key.startsWith('data-');
	}
	
	/**
	 * データ属性を設定する
	 */
	function setDataObj(id, val, forcingFlg) {
		Object.keys(val).forEach(function(key) {
			if (isDataAttrKey(camelToSnake(key, '-')) || forcingFlg) {
				var v = val[key];
				if (typeof v === 'object') {
					setDataObj(id, v, true);
				} else {
					$('#' + id).attr(forcingFlg ? 'data-' + key : camelToSnake(key, '-'), v);
				}
			}
		});
	}
	
</script>
</num-input>
